#include "nxlib.h"

int
XDrawPoint(Display * display, Drawable d, GC gc, int x, int y)
{
	GrPoint(d, gc->gid, x, y);
	return 1;
}

int
XDrawPoints(Display * display, Drawable d, GC gc,
	    XPoint * points, int npoints, int mode)
{
	// Giosis/Foedrowitz  2005nov14  Fixed bug: only first coordinate set was used.
	int i;
	if (mode == CoordModeOrigin)
  {
	
		for (i = 0; i < npoints; i++)
    {
			GrPoint(d, gc->gid, points[i].x, points[i].y);
		}
	}
  else
  {
		int prevx = 0, prevy = 0;
		for (i = 0; i < npoints; i++)
    {
			GrPoint(d, gc->gid, prevx + points[i].x,
				prevy + points[i].y);
			  prevx += points[i].x;
			  prevy += points[i].y;
		}
	}
	return 1;
}
