#define MWINCLUDECOLORS
#include "nxlib.h"

#define AllMaskBits (CWBackPixmap|CWBackPixel|CWBorderPixmap|\
		     CWBorderPixel|CWBitGravity|CWWinGravity|\
		     CWBackingStore|CWBackingPlanes|CWBackingPixel|\
		     CWOverrideRedirect|CWSaveUnder|CWEventMask|\
		     CWDontPropagate|CWColormap|CWCursor)

Window
XCreateWindow(Display *dpy, Window parent, int x, int y,
	unsigned int width, unsigned int height, unsigned int borderWidth,
	int depth, unsigned int class, Visual *visual, unsigned long valuemask,
	XSetWindowAttributes *attributes)
{ /* Foedrowitz 2006mar09 function rewritten*/
	Window		wid;
  GR_WM_PROPERTIES props; 
  props.props=0;
  props.flags=0;

	// FIXME: handle CopyFromParent for depth, visual

	if (parent == 0)
		parent = GR_ROOT_WINDOW_ID;

  if (class == InputOnly)
  {
    wid=GrNewInputWindow((GR_WINDOW_ID)parent, x, y, width, height);
  }
  else
  {
  	GR_COLOR bkgnd = WHITE;
	  GR_COLOR border = BLACK;
    if (valuemask & CWBackPixel)
		  bkgnd = _nxColorvalFromPixelval(dpy, attributes->background_pixel);
    if (valuemask & CWBorderPixel)
		  border = _nxColorvalFromPixelval(dpy, attributes->border_pixel);
	  wid=GrNewWindow((GR_WINDOW_ID)parent, x, y, width, height, borderWidth, bkgnd, border);
  }

	if (!wid)
		return 0;

	/* if override_redirect set, assume popup-style window*/
	if ((valuemask & CWOverrideRedirect) && attributes->override_redirect)
  {
		props.props |= GR_WM_PROPS_NODECORATE;
		props.flags |= GR_WM_FLAGS_PROPS;
  }

  if (props.flags)
	  GrSetWMProperties(wid, &props);

	if (valuemask & CWEventMask)
		XSelectInput( dpy, wid, attributes->event_mask);

  if (valuemask & CWCursor)
	  GrSetWindowCursor(wid, attributes->cursor);

  /* other attributes are not supported by Nano-X */

	return wid;
}
